//------------------------------------------------------------------
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed
#property indicator_color3 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern double Samples1       = 41;
extern double Samples2       = 25;
extern double Suppression_dB =  0;
extern bool   AutoGainOn     = true;
extern int    PriceToUse     = PRICE_CLOSE;

//
//
//
//
//

double buffUp[];
double buffNe[];
double buffDn[];
double state[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,buffUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffNe); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,state);

      indicatorFileName = WindowExpertName();
      calculateValue    = TimeFrame=="calculateValue";   if (calculateValue) { return(0); }
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     { return(0); }
      timeFrame         = stringToTimeFrame(TimeFrame);
   
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { buffUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         double kalman1 = iCustom(NULL,0,"KalmanAGJW - new",Samples1,0,0,Suppression_dB,AutoGainOn,0,i);
         double kalman2 = iCustom(NULL,0,"KalmanAGJW - new",Samples2,0,0,Suppression_dB,AutoGainOn,0,i);
         double price   = iMA(NULL,0,1,0,MODE_SMA,PriceToUse,i);
            state[i]  = 0;
            buffNe[i] = EMPTY_VALUE;
            buffUp[i] = EMPTY_VALUE;
            buffDn[i] = EMPTY_VALUE;
               if (price>kalman1 && price>kalman2) state[i] =  1;
               if (price<kalman1 && price<kalman2) state[i] = -1;
               if (state[i] ==  0) buffNe[i] = 1;
               if (state[i] ==  1) buffUp[i] = 1;
               if (state[i] == -1) buffDn[i] = 1;
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Samples1,Samples2,Suppression_dB,AutoGainOn,PriceToUse,0,y);
         buffDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Samples1,Samples2,Suppression_dB,AutoGainOn,PriceToUse,1,y);
         buffNe[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Samples1,Samples2,Suppression_dB,AutoGainOn,PriceToUse,2,y);
   }      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}